/*
Gemma's Freedom Planet dance
Lua originally from TA Tails. 
Re-tooled for this by Mylo T with permission from WhisperVII.
*/

freeslot("S_GEMMA_DANCE")
freeslot("SPR2_LILA")
states[S_GEMMA_DANCE] = {SPR_PLAY, SPR2_LILA, 3, nil, 0, 0, S_GEMMA_DANCE}

addHook("PlayerThink",function(p)
	local mo = p.mo
	local skin = "gemma"
	
	-- Default to "not dancing"
	if p.gemmadance == nil
		p.gemmadance = false
	end
	
	if not ((mo and mo.valid) and mo.health) then return end
    if (mo.skin != skin) then return end

	if (p.cmd.buttons & BT_CUSTOM2
	and not p.gemmadance 
	and mo.state ~= S_PLAY_FLY 
	and mo.state ~= S_PLAY_JUMP
	and mo.state ~= S_PLAY_FALL
	and p.speed == 0)
		mo.state = S_GEMMA_DANCE
		p.gemmadance = true
		if S_MusicName(p) ~= "FPLDNC"
            S_ChangeMusic("FPLDNC", true, p)
		end
	end
	if p.gemmadance     
        if p.speed ~= 0 or mo.state ~= S_GEMMA_DANCE
			mo.state = S_PLAY_STND
            p.gemmadance = false
			if S_MusicName(p) == "FPLDNC"
				P_RestoreMusic(p)
			end
        end
		if not P_IsObjectOnGround(mo)
			p.gemmadance = false
			mo.state = S_PLAY_JUMP
			if S_MusicName(p) == "FPLDNC"
				P_RestoreMusic(p)
			end
		end
    end
end)